Index: src/perl/register-dataset.cgi
===================================================================
--- src/perl/register-dataset.cgi	(revision 4079)
+++ src/perl/register-dataset.cgi	(revision 4080)
@@ -30,6 +30,7 @@
 
 use Metacat;
 use AppConfig qw(:expand :argcount);
+use Config::Properties;
 use XML::LibXML;
 use XML::LibXSLT;
 use Template;
@@ -42,10 +43,26 @@
 use strict;
 
 # Global configuration paramters
-#my $cfgdir = "/usr/local/devtools/tomcat/webapps/knb/style/skins";
-my $cfgdir = "@install-dir@@style-skins-relpath@";
-my $tmpdir = "@temp-dir@";
-my $templatesdir = "@install-dir@@style-common-relpath@/templates";
+my $cgiUrl = $ENV{'SCRIPT_FILENAME'};
+my $workingDirectory = dirname($cgiUrl);
+my $metacatProps = "${workingDirectory}/../WEB-INF/metacat.properties";
+my $properties = new Config::Properties();
+unless (open (METACAT_PROPERTIES, $metacatProps)) {
+    print "Content-type: text/html\n\n";
+    print "Unable to locate Metacat properties. Working directory is set as '$workingDirectory', is this correct?";
+    exit(0);
+}
+
+$properties->load(*METACAT_PROPERTIES);
+
+# local directory configuration
+my $configDir = $properties->getProperty('config-dir'); # skins directory
+my $tmpDir = $properties->getProperty('temp-dir');
+my $xslConvDir = "$configDir/lib/style";
+
+# url configuration
+my $metacatUrl = $properties->getProperty('metacatUrl');
+
 my $now = time;
 my $xslConvDir = "$cfgdir/lib/style/";
 
@@ -57,151 +74,99 @@
 my $error = 0;
 my @errorMessages;
 
-# create a new AppConfig object and load our config parameters
-# note that this requires the form submission to have a "cfg" paramter
-# to determine which config file to load
-my $config = AppConfig->new({
-    GLOBAL => { ARGCOUNT => ARGCOUNT_ONE, } });
-
-$config->define("metacatUrl");
-$config->define("username");
-$config->define("password");
-$config->define("ldapUrl");
-$config->define("defaultScope");
-$config->define("organization");
-$config->define("orgabbrev");
-$config->define("orgurl");
-$config->define("accesspubid");
-$config->define("accesssysid");
-$config->define("datasetpubid");
-$config->define("datasetsysid");
-$config->define("showSiteList", { DEFAULT => 'true'} );
-$config->define("lsite", { DEFAULT => 'station'} );
-$config->define("usite", { DEFAULT => 'Station'} );
-$config->define("showWgList", { DEFAULT => 'true'} );
-$config->define("showOrganization", { DEFAULT => 'true'} );
-$config->define("hasKeyword", { DEFAULT => 'true'} );
-$config->define("hasTemporal", { DEFAULT => 'true'} );
-$config->define("hasSpatial", { DEFAULT => 'true'} );
-$config->define("hasTaxonomic", { DEFAULT => 'true'} );
-$config->define("hasMethod", { DEFAULT => 'true'} );
-$config->define("hasUpload", { DEFAULT => 'false'} );
-$config->define("temporalRequired", { DEFAULT => 'true'} );
-$config->define("spatialRequired", { DEFAULT => 'true'} );
-$config->define("contactEmailAddressRequired", { DEFAULT => 'false'} );
-$config->define("publicReadable", { DEFAULT => 'true'} );
-$config->define("adminIsDocOwner", { DEFAULT => 'false'} );
-$config->define("moderators", { DEFAULT => ''} );
-$config->define("mailhost");
-$config->define("sender");
-$config->define("recipient");
-$config->define("adminname");
-if ($FORM::cfg eq 'nceas') {
-    $config->define("nceas_db");
-    $config->define("nceas_db_user");
-    $config->define("nceas_db_password");
-}
-$config->define("responseTemplate", { DEFAULT => 'crap.tmpl'} );
-$config->define("entryFormTemplate", { DEFAULT => 'crap.tmpl'} );
-$config->define("guideTemplate", { DEFAULT => 'crap.tmpl'} );
-$config->define("loginFormTemplate", { DEFAULT => 'loginForm.tmpl'} );
-$config->define("confirmDataTemplate", { DEFAULT => 'crap.tmpl'} );
-$config->define("deleteDataTemplate", { DEFAULT => 'crap.tmpl'} );
-$config->define("modEmailNotificationTemplate", { DEFAULT => 'crap.tmpl'} );
-$config->define("modResultTemplate", { DEFAULT => 'crap.tmpl'} );
-$config->define("getReviewsTemplate", { DEFAULT => 'crap.tmpl'} );
-$config->define("debug", { DEFAULT => '0'} );
-$config->define("lat", { ARGCOUNT => ARGCOUNT_HASH} );
-$config->define("lon", { ARGCOUNT => ARGCOUNT_HASH} );
-
-
+my $skinProperties = new Config::Properties();
 if (! hasContent($FORM::cfg)) {
     $error = "Application misconfigured.  Please contact the administrator.";
     push(@errorMessages, $error);
 } else {
-    my $cfgfile = $cfgdir . "/" . $FORM::cfg . "/" . $FORM::cfg . ".cfg";
-    $config->file($cfgfile);
+    my $skinProps = "$configDir/$FORM::cfg/$FORM::cfg.properties";
+    unless (open (SKIN_PROPERTIES, $skinProps)) {
+        print "Content-type: text/html\n\n";
+        print "Unable to locate skin properties at $skinProps.  Is this path correct?";
+        exit(0);
+    }
+    $skinProperties->load(*SKIN_PROPERTIES);
 }
 
-my $metacatUrl = $config->metacatUrl();
-my $username = $config->username();
-my $password = $config->password();
-my $ldapUrl = $config->ldapUrl();
-my $defaultScope = $config->defaultScope();
-my $organization = $config->organization();
-my $orgabbrev = $config->orgabbrev();
-my $orgurl = $config->orgurl();
-my $orgfilter = $organization;
-      $orgfilter =~ s/ /%20/g;
-my $responseTemplate = $config->responseTemplate();
-my $entryFormTemplate = $config->entryFormTemplate();
-my $deleteDataTemplate = $config->deleteDataTemplate();
-my $guideTemplate = $config->guideTemplate();
-my $loginFormTemplate = $config->loginFormTemplate();
-my $confirmDataTemplate = $config->confirmDataTemplate();
-my $modEmailNotificationTemplate = $config->modEmailNotificationTemplate();
-my $modResultTemplate = $config->modResultTemplate();
-my $getReviewsTemplate = $config->getReviewsTemplate();
-my $accesspubid = $config->accesspubid();
-my $accesssysid = $config->accesssysid();
-my $datasetpubid = $config->datasetpubid();
-my $datasetsysid = $config->datasetsysid();
-my $showSiteList = $config->showSiteList();
-my $lsite = $config->lsite();
-my $usite = $config->usite();
-my $showWgList = $config->showWgList();
-my $showOrganization = $config->showOrganization();
-my $hasKeyword = $config->hasKeyword();
-my $hasTemporal = $config->hasTemporal();
-my $hasSpatial = $config->hasSpatial();
-my $hasTaxonomic = $config->hasTaxonomic();
-my $hasMethod = $config->hasMethod();
-my $hasUpload = $config->hasUpload();
-my $temporalRequired = $config->temporalRequired();
-my $spatialRequired = $config->spatialRequired();
-my $contactEmailAddressRequired = $config->contactEmailAddressRequired();
-my $publicReadable = $config->publicReadable();
-my $adminIsDocOwner = $config->adminIsDocOwner();
-my $moderators = $config->moderators();
-my $mailhost = $config->mailhost();
-my $sender = $config->sender();
-my $recipient = $config->recipient();
-my $adminname = $config->adminname();
-my $nceas_db;
-my $nceas_db_user;
-my $nceas_db_password;
-if ($FORM::cfg eq 'nceas') {
-    $nceas_db = $config->nceas_db();
-    $nceas_db_user = $config->nceas_db_user();
-    $nceas_db_password = $config->nceas_db_password();
+# replacements for appconfig values using properties
+my $metacatUrl = $properties->getProperty('metacatUrl');
+my $moderators = $properties->getProperty('ldap.moderators');
+my $config = $properties->splitToTree(qr/\./, 'registry.config');
+my $templates = $properties->splitToTree(qr/\./, 'registry.templates');
+my $modules = $properties->splitToTree(qr/\./, 'registry.modules');
+my $required = $properties->splitToTree(qr/\./, 'registry.required');
+my $spatial = $properties->splitToTree(qr/\./, 'registry.spatial');
+
+my $metacatUrl = $properties->getProperty('metacatUrl');
+my $username = $config->{'username'};
+my $password = $config->{'password'};
+
+# XXX replace these with the proper array versions once the templates work correctly
+my $showWgList = $required->{'wgList'};
+my $showOrganization = $required->{'organization'};
+my $hasKeyword = $required->{'keyword'};
+my $hasTemporal = $required->{'temporal'};
+my $hasSpatial = $required->{'spatial'};
+my $hasTaxonomic = $required->{'taxonomic'};
+my $hasMethod = $required->{'method'};
+my $hasUpload = $required->{'upload'};
+
+# contains sender, recipient, admin, mailhost
+my $email = $properties->splitToTree(qr/\./, 'email');
+
+# set stderr printing if configured
+my $debug_enabled = $config->{'debug'};
+if ($FORM::debug) {
+    $debug_enabled = $FORM::debug;
 }
-my $debug = $config->debug();
+my $lat = $config->get('lat');
+my $lon = $config->get('lon');
+
+my $metacatUrl = $properties->getProperty('metacatUrl');
+my $username = $config->{'username'};
+my $password = $config->{'password'};
+
+# TODO SCW replace these with the proper array versions once the templates work correctly
+my $showWgList = $required->{'wgList'};
+my $showOrganization = $required->{'organization'};
+my $hasKeyword = $required->{'keyword'};
+my $hasTemporal = $required->{'temporal'};
+my $hasSpatial = $required->{'spatial'};
+my $hasTaxonomic = $required->{'taxonomic'};
+my $hasMethod = $required->{'method'};
+my $hasUpload = $required->{'upload'};
+
+# contains sender, recipient, admin, mailhost
+my $email = $properties->splitToTree(qr/\./, 'email');
+
+# set stderr printing if configured
+my $debug_enabled = $config->{'debug'};
 if ($FORM::debug) {
-    $debug = $FORM::debug;
+    $debug_enabled = $FORM::debug;
 }
 
-# 1.8.1 temporary baseUrl fix
-my $baseUrl = $metacatUrl;
-$baseUrl =~ s/metacat$//;
+# populate db parameters for NCEAS AdminDB
+my $database = '';
+if ($FORM::cfg eq 'nceas') {
+    my $database = $properties->splitToTree(qr/\./, 'registry.db');
+}
 
-my $lat = $config->get('lat');
-my $lon = $config->get('lon');
-
-# Convert the lat and lon configs into usable data structures
+#Convert the lat and lon configs into usable data structures
 my @sitelist;
 my %siteLatDMS;
 my %siteLongDMS;
-foreach my $newsite (keys %$lat) {
-    my ($latd, $latm, $lats, $latdir) = split(':', $lat->{$newsite});
-    my ($lond, $lonm, $lons, $londir) = split(':', $lon->{$newsite});
-    push(@sitelist, $newsite);
-    $siteLatDMS{$newsite} = [ $latd, $latm, $lats, $latdir ];
-    $siteLongDMS{$newsite} = [ $lond, $lonm, $lons, $londir ];
+while ( my ($key, $value) = each (%$spatial)) {
+    my ($name, $lon, $lat) = split(",", $value);
+    my ($latd, $latm, $lats, $latdir) = split(':', $lat);
+    my ($lond, $lonm, $lons, $londir) = split(':', $lon);
+    push(@sitelist, $name);
+    $siteLatDMS{$name} = [ $latd, $latm, $lats, $latdir ];
+    $siteLongDMS{$name} = [ $lond, $lonm, $lons, $londir ];
 }
 
 # set some configuration options for the template object
 my $ttConfig = {
-             INCLUDE_PATH => $templatesdir, 
+             INCLUDE_PATH => $properties->getProperty('templates-dir'),
              INTERPOLATE  => 0,                    
              POST_CHOMP   => 1,
              #DEBUG        => 'all',
@@ -211,14 +176,16 @@
 my $template = Template->new($ttConfig) || die $Template::ERROR, "\n";
 
 # Set up the template information that is common to all forms
+$$templateVars{'styleSkinsPath'} = $properties->getProperty('style-skins-path');
+$$templateVars{'styleCommonPath'} = $properties->getProperty('style-common-path');
+$$templateVars{'servletPath'} = $properties->getProperty('servlet-path');
+$$templateVars{'metacatUrl'} = $metacatUrl;
+$$templateVars{'cgiPrefix'} = $properties->getProperty('cgi-prefix');
 $$templateVars{'cfg'} = $FORM::cfg;
-$$templateVars{'recipient'} = $recipient;
-$$templateVars{'adminname'} = $adminname;
-$$templateVars{'organization'} = $organization;
-$$templateVars{'orgabbrev'} = $orgabbrev;
-$$templateVars{'orgurl'} = $orgurl;
-$$templateVars{'orgfilter'} = $orgfilter;
-$$templateVars{'baseUrl'} = $baseUrl;
+$$templateVars{'email'} = $email;
+$$templateVars{'templates'} = $templates;
+$$templateVars{'required'} = $required;
+$$templateVars{'config'} = $config;
 
 debug("Registry: Initialized -- stage set: $FORM::stage");
 
@@ -227,7 +194,7 @@
     debug("Registry: No configuration set.");
     print "Content-type: text/html\n\n";
     $$templateVars{'message'} = 'Error: The registry requires a skin name to continue.';
-    $template->process( $loginFormTemplate, $templateVars);
+    $template->process( $templates->{'login'}, $templateVars);
     exit(0);
 }
 
@@ -240,13 +207,6 @@
     exit(0);
 }
 
-# FIXME: temporary 1.8.1 fix to prevent missing upload directory from causing errors
-if (not -W $tmpdir) {
-    debug("Registry Error: Can't write files to $tmpdir, disabling file uploads");
-    #push(@errorMessages, "Unable to write files to temporary folder. Email sysadmin.");
-    $hasUpload = 'false';
-}
-
 # Process the form based on stage parameter. 
 if ($FORM::stage =~ "loginform") {
     print "Content-type: text/html\n\n";
@@ -259,11 +219,11 @@
 
     if ( $session->is_empty ) {
 	# no session found ... redirect to login page template
-        $template->process( $loginFormTemplate, $templateVars);
+        $template->process( $templates->{'login'}, $templateVars);
     } else {
 	# session found ... delete the session....
 	$session->delete();
-	$template->process( $loginFormTemplate, $templateVars);
+	$template->process( $templates->{'login'}, $templateVars);
     }
 	exit(0);
 } elsif ($FORM::stage =~ "logout") {
@@ -294,7 +254,7 @@
 if ($FORM::stage =~ "guide") {
     # Send back the information on how to fill the form
     $$templateVars{'section'} = "Guide on How to Complete Registry Entries";
-    $template->process( $guideTemplate, $templateVars);
+    $template->process( $template->{'guide'}, $templateVars);
     exit(0);
 
 } elsif ($FORM::stage =~ "insert") {
@@ -316,7 +276,7 @@
     if ( $session->is_empty ) {
         # no session found ... redirect to login page template
     	$$templateVars{'message'} = 'You must login to modify your dataset.';
-        $template->process( $loginFormTemplate, $templateVars);
+        $template->process( $templates->{'login'}, $templateVars);
     } else {
     	# Show the form will all the values filled in.
     	my @sortedSites;
@@ -340,7 +300,7 @@
     } else {
     $$templateVars{'status'} = "Cancel";
     $$templateVars{'function'} = "cancel";
-    $template->process( $responseTemplate, $templateVars);
+    $template->process( $templates->{'response'}, $templateVars);
     exit(0);
     }
 
@@ -348,7 +308,7 @@
     # Deletion of a file has been requested. 
     # Ask for username and password using deleteDataForm
     $$templateVars{'docid'} = $FORM::docid;
-    $template->process( $deleteDataTemplate, $templateVars);
+    $template->process( $templates->{'deleteData'}, $templateVars);
     exit(0);
 
 }elsif ($FORM::stage !~ "confirmed") {
@@ -360,7 +320,7 @@
         # no session found ... redirect to login page template
         $$templateVars{'showInstructions'} = 'true';
         $$templateVars{'message'} = 'You must login to register your dataset.';
-        $template->process( $loginFormTemplate, $templateVars);
+        $template->process( $templates->{'login'}, $templateVars);
     } else {
 
     	# Hence, send back entry form for entry of data.  
@@ -369,34 +329,35 @@
     	foreach my $site (sort @sitelist) {
         	push(@sortedSites, $site);
     	}
-    
+
     	if ($FORM::cfg eq 'nceas') {
-        	my $projects = getProjectList();
+        	my $projects = getProjectList($database);
         	$$templateVars{'projects'} = $projects;
         	$$templateVars{'wg'} = \@FORM::wg;
     	}
 
-    	$$templateVars{'showSiteList'} = $showSiteList;
-    	$$templateVars{'lsite'} = $lsite;
-    	$$templateVars{'usite'} = $usite;
-    	$$templateVars{'showWgList'} = $showWgList;
-    	$$templateVars{'showOrganization'} = $showOrganization;
-    	$$templateVars{'hasKeyword'} = $hasKeyword;
-    	$$templateVars{'hasTemporal'} = $hasTemporal;
-    	$$templateVars{'hasSpatial'} = $hasSpatial;
-    	$$templateVars{'hasTaxonomic'} = $hasTaxonomic;
-    	$$templateVars{'hasMethod'} = $hasMethod;
-      $$templateVars{'hasUpload'} = $hasUpload;
-    	$$templateVars{'temporalRequired'} = $temporalRequired;
-    	$$templateVars{'spatialRequired'} = $spatialRequired;
-    	$$templateVars{'contactEmailAddressRequired'} = $contactEmailAddressRequired;
+        #$$templateVars{'required'} = $required; 
+        $$templateVars{'templates'} = $templates;
+        $$templateVars{'showSiteList'} = $required->{'siteList'};
+        $$templateVars{'site'} = $config->{'site'};
+        $$templateVars{'showWgList'} = $showWgList;
+        $$templateVars{'showOrganization'} = $showOrganization;
+        $$templateVars{'hasKeyword'} = $hasKeyword;
+        $$templateVars{'hasTemporal'} = $hasTemporal;
+        $$templateVars{'hasSpatial'} = $hasSpatial;
+        $$templateVars{'hasTaxonomic'} = $hasTaxonomic;
+        $$templateVars{'hasMethod'} = $hasMethod;
+        $$templateVars{'hasUpload'} = $hasUpload;
+        $$templateVars{'temporalRequired'} = $required->{'temporalRequired'};
+        $$templateVars{'spatialRequired'} = $required->{'spatialRequired'};
+        $$templateVars{'contactEmailAddressRequired'} = $required->{'contactEmail'};
 
-    	$$templateVars{'siteList'} = \@sortedSites;
-    	$$templateVars{'section'} = "Entry Form";
-    	$$templateVars{'docid'} = "";
-    	debug("Registry: Sending form: ready to process template");
-    	$template->process( $entryFormTemplate, $templateVars);
-    	debug("Registry: Sending form: template processed");
+        $$templateVars{'siteList'} = \@sortedSites;
+        $$templateVars{'section'} = "Entry Form";
+        $$templateVars{'docid'} = "";
+        debug("Registry: Sending form: ready to process template");
+        $template->process( $templates->{'entry'}, $templateVars);
+        debug("Registry: Sending form: template processed");
    }
    exit(0);
 }
@@ -444,12 +405,13 @@
     # Login to metacat
     my ($dname, $userPass) = getCredentials();
     my $response = $metacat->login($dname, $userPass);
+    my $errorMessage = "";
 
     # Parameters have been validated and Create the XML document
     my $xmldoc = createXMLDocument();
     
     # Write out the XML file for debugging purposes
-    #my $testFile = $tmpdir . "/test-file.xml";
+    #my $testFile = $tmpDir . "/test-file.xml";
     #open (TFILE,">$testFile") || die ("Cant open xml file...\n");
     #print TFILE $xmldoc;
     #close(TFILE);
@@ -467,11 +429,11 @@
         $$templateVars{'cfg'} = $FORM::cfg;
         $$templateVars{'function'} = "submitted";
         $$templateVars{'section'} = "Submission Status";
-        $template->process( $responseTemplate, $templateVars);
+        $template->process( $templates->{'response'}, $templateVars);
         exit(0);
     } else {
 
-    	if($adminIsDocOwner eq 'true'){
+    	if($config->{'adminIsDocOwner'} eq 'true'){
     		$response = $metacat->login($username, $password);
    	 	if (! $response) {
         		push(@errorMessages, $metacat->getMessage());
@@ -482,7 +444,7 @@
         		$$templateVars{'cfg'} = $FORM::cfg;
         		$$templateVars{'function'} = "submitted";
         		$$templateVars{'section'} = "Submission Status";
-        		$template->process( $responseTemplate, $templateVars);
+        		$template->process( $templates->{'response'}, $templateVars);
         		exit(0);
     		}
     	} 
@@ -493,7 +455,7 @@
             # document is being inserted 
             my $notunique = "NOT_UNIQUE";
             while ($notunique eq "NOT_UNIQUE") {
-                $docid = newAccessionNumber($defaultScope);
+                $docid = newAccessionNumber($config->{'scope'});
                 
                 $xmldocWithDocID = $xmldoc;
                 $xmldocWithDocID =~ s/docid/$docid/;
@@ -508,7 +470,7 @@
                 $notunique = insertMetadata($xmldocWithDocID, $docid);
                 #  if (!$notunique) {
                 # Write out the XML file for debugging purposes
-                #my $testFile = $tmpdir . "/test-new.xml";
+                #my $testFile = $tmpDir . "/test-new.xml";
                 #open (TFILE,">$testFile") || die ("Cant open xml file...\n");
                 #print TFILE $newdoc;
                 #close(TFILE);
@@ -517,7 +479,7 @@
                 # The id wasn't unique, so update our lastid file
                 if ($notunique eq "NOT_UNIQUE") {
                     debug( "Registry: Updating lastid (B1.1)");
-                    updateLastId($defaultScope);
+                    updateLastId($config->{'scope'});
                 }
             }
             debug("Registry: B2");
@@ -569,7 +531,7 @@
             # Create our HTML response and send it back
             $$templateVars{'function'} = "modified";
             $$templateVars{'section'} = "Modification Status";
-            $template->process( $responseTemplate, $templateVars);
+            $template->process( $templates->{'response'}, $templateVars);
     
             exit(0);
         }
@@ -606,7 +568,7 @@
 $$templateVars{'function'} = "submitted";
 $$templateVars{'section'} = "Submission Status";
 
-$template->process( $responseTemplate, $templateVars);
+$template->process( $templates->{'response'}, $templateVars);
 
 exit(0);
 
@@ -630,7 +592,7 @@
       (my $foundScope, my $id, my $rev) = split(/\./, $docid);
       debug("Docid is: $docid\n");
       debug("Lastid is: $id");
-      my $scopeFile = $cfgdir . "/" . $FORM::cfg . "/" . $scope . ".lastid";
+      my $scopeFile = $configDir . "/" . $FORM::cfg . "/" . $scope . ".lastid";
       # FIXME: skins dir isn't generally writeable by the HTTP server, use tmp instead
       open(LASTID, "+>$scopeFile") or 
           die "Failed to open lastid file for writing!";
@@ -691,7 +653,7 @@
   my $docrev = 1;
   my $lastid = 1;
 
-  my $scopeFile = $cfgdir . "/" . $FORM::cfg . "/" . $scope . ".lastid";
+  my $scopeFile = $configDir . "/" . $FORM::cfg . "/" . $scope . ".lastid";
   if (-e $scopeFile) {
     open(LASTID, "<$scopeFile") or die "Failed to generate accession number!";
     $lastid = <LASTID>;
@@ -719,7 +681,7 @@
     my @invalidParams;
 
     push(@invalidParams, "Name of the Project is not selected in the form.")
-        if (scalar(@FORM::wg) == 0 && $showWgList eq 'true');
+        if (scalar(@FORM::wg) == 0 && $required->{'wgList'} eq 'true');
     push(@invalidParams, "First name of person entering the form is missing.")
         unless hasContent($FORM::providerGivenName);
     push(@invalidParams, "Last name of person entering the form is missing.")
@@ -726,7 +688,7 @@
         unless hasContent($FORM::providerSurName);
     push(@invalidParams, "Dataset title is missing.")
         unless hasContent($FORM::title);
-    push(@invalidParams, $usite." name is missing.")
+    push(@invalidParams, ucfirst($config->{'site'})." name is missing.")
         unless ((hasContent($FORM::site) && !($FORM::site =~ /^Select/)) ||
                 $FORM::cfg eq "nceas");
     push(@invalidParams, "First name of principal data set owner is missing.")
@@ -1051,14 +1013,14 @@
     my $fileNum = shift;
     my $fileHash = param("upload_$fileNum");
     my $fileName = param("uploadname_$fileNum");
+    my $contentType = param("uploadtype_$fileNum");
     my $filePerm = param("uploadperm_$fileNum");
-    my $contentType = param("uploadtype_$fileNum");
     my $cleanName = $fileName;
 
     # normalize input filenames; Windows filenames include full paths
     $cleanName =~ s/.*[\/\\](.*)/$1/;
 
-    my $outFile = $tmpdir . "/" . $cleanName;
+    my $outFile = $tmpDir . "/" . $cleanName;
     #debug("Reading file from disk: $outFile");
 
     my $fileSize = stat($outFile)->size;
@@ -1075,15 +1037,11 @@
         return 0;
     }
 
-    #my ($dname, $userPass) = getCredentials();
-    #debug("Logging in with $dname, $userPass");
-    #$metacat->login($username, $password);
-
-    my $docid = newAccessionNumber($defaultScope);
+    my $docid = newAccessionNumber($config->{'scope'});
     my $unique = uploadData($outFile, $docid);
     if (!$unique) {
         debug( "Registry: Updating lastid file");
-        updateLastId($defaultScope);
+        updateLastId($config->{'scope'});
     }
 
     my $entityid = $fileHash."001";
@@ -1129,7 +1087,6 @@
 
     # file is in Metacat, generate the pertinent EML elements
     my $contentType = uploadInfo($fileName)->{'Content-Type'};
-
     # occasionally CGI.pm doesn't get the file info.  In this case,
     # use a default MIME type of text/plain.  Seems fixed in the newer CGI.pm:
     # http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=313141
@@ -1165,7 +1122,7 @@
     $ctx->add($fileData);
     my $digest = $ctx->hexdigest;
 
-    my $outputName = $tmpdir . "/" . $cleanName;
+    my $outputName = $tmpDir . "/" . $cleanName;
     open(OUT,">$outputName") or die "Could not open: $!";
     print OUT $fileData;
     close(OUT);
@@ -1176,7 +1133,7 @@
 
 sub deleteFile {
     my $input = shift;
-    my $fileName = $tmpdir . "/" . $input;
+    my $fileName = $tmpDir . "/" . $input;
 
     if (-e $fileName) {
         unlink $fileName or
@@ -1310,6 +1267,7 @@
                   $roleName = $defaultRole;
                 }
 
+                #debug("XXXXX role name: " . $roleName);
                 push (@{$orig{$roleName}}, [$first, $last, $origRole]);
             }
         }
@@ -1439,7 +1397,7 @@
         foreach my $x (@$a_ref) {
             my ($kw, $kwType) = @$x;
             $kwElem .= "<keyword ";
-            if (hasContent($kwType) && $kwType ne "None") {
+            if (hasContent($kwType) && $kwType != "None") {
                  $kwElem.= "keywordType=\"".lc($kwType)."\"";
             }
             $kwElem .= ">$kw</keyword>\n";
@@ -1882,7 +1840,7 @@
         $access .= allowElement(getUsername(), 'read', 'write'); 
     }
 
-    if($publicReadable eq "true"){
+    if($config->{'publicReadable'} eq "true"){
         $access .= allowElement('public', 'read');
     }
     $access .= "</access>\n";
@@ -1906,7 +1864,7 @@
     my $username = '';
      
     if ($FORM::username ne '') {
-        $username = "uid=$FORM::username,o=$FORM::organization,dc=ecoinformatics,dc=org";
+        $username = "uid=$FORM::username,o=$FORM::organization,dc=ecoinformatics,dc=org";    
     } else {
         my $session = CGI::Session->load();
         if ( !$session->is_empty ) {
@@ -1955,12 +1913,12 @@
         push(@errorMessages, $error);
     } elsif ($doc=~ /<error/) {
     if ( $doc=~ /public/){
-        	$error ="Error in reading the eml document. Please check if you are logged in.";
-        	push(@errorMessages, $error);
-	} else {
-        	$error ="Error in reading the eml document. Please check if you have access to read the document";
-        	push(@errorMessages, $error);	
-	}
+          $error ="Error in reading the eml document. Please check if you are logged in.";
+          push(@errorMessages, $error);
+  } else {
+          $error ="Error in reading the eml document. Please check if you have access to read the document";
+          push(@errorMessages, $error); 
+  }
     } else {
         $findType = $xmldoc->findnodes('//dataset/identifier');
         if ($findType->size() > 0) {
@@ -1975,7 +1933,7 @@
                     # If the file is already in @fileArray then do not add it 
                     $alreadyInArray = 0;
                     foreach $element (@fileArray) {
-                        $tempfile = $tmpdir."/".$pushDoc;
+                        $tempfile = $tmpDir."/".$pushDoc;
                         if ($element eq $pushDoc) {
                             $alreadyInArray = 1;
                         }
@@ -1982,7 +1940,7 @@
                     }
             
                     if (!$alreadyInArray) {
-                        $tempfile = $tmpdir."/".$pushDoc;
+                        $tempfile = $tmpDir."/".$pushDoc;
                         $response = "";
                         $response = $metacat->read($pushDoc);    
                         if (! $response) {
@@ -2005,7 +1963,7 @@
 
             # Read the main document. 
 
-            $tempfile = $tmpdir."/".$docid;
+            $tempfile = $tmpDir."/".$docid;
             open (TFILE,">$tempfile") || die ("Cant open xml file...\n");
             print TFILE $doc;
             close(TFILE);
@@ -2018,13 +1976,13 @@
             my $resultsheet;
         
             $xslt = XML::LibXSLT->new();
-            $tempfile = $tmpdir."/"."triple_info.xsl";
+            $tempfile = $tmpDir."/"."triple_info.xsl";
     
             $triplesheet = $xslt->parse_stylesheet_file($tempfile);
 
-            $results = $triplesheet->transform($xmldoc, packageDir => "\'$tmpdir/\'", packageName => "\'$docid\'");
+            $results = $triplesheet->transform($xmldoc, packageDir => "\'$tmpDir/\'", packageName => "\'$docid\'");
 
-            $tempfile = $tmpdir."/"."emlb6toeml2.xsl";
+            $tempfile = $tmpDir."/"."emlb6toeml2.xsl";
             $stylesheet = $xslt->parse_stylesheet_file($tempfile);
             $resultsheet = $stylesheet->transform($results);
         
@@ -2051,9 +2009,9 @@
 ################################################################################
 sub modifyData {
 
-    my $xmldoc = readDocumentFromMetacat();    	
+    my $xmldoc = readDocumentFromMetacat();     
     if (!scalar(@errorMessages)) {
-    	getFormValuesFromEml2($xmldoc);
+      getFormValuesFromEml2($xmldoc);
     }
 
     if (scalar(@errorMessages)) {
@@ -2063,10 +2021,10 @@
         $error = 1;
         $$templateVars{'function'} = "modification";
         $$templateVars{'section'} = "Modification Status";
-        $template->process( $responseTemplate, $templateVars); 
+        $template->process( $templates->{'response'}, $templateVars); 
     } else {
         $$templateVars{'form'} = 're_entry';
-        $template->process( $entryFormTemplate, $templateVars);
+        $template->process( $templates->{'entry'}, $templateVars);
     }
 }
 
@@ -2088,10 +2046,10 @@
     my $foundDSO;
 
     # set variable values
-    $$templateVars{'showSiteList'} = $showSiteList;
-    $$templateVars{'lsite'} = $lsite;
-    $$templateVars{'usite'} = $usite;
-    $$templateVars{'showWgList'} = $showWgList;
+    $$templateVars{'required'} = $required;
+    $$templateVars{'showSiteList'} = $required->{'siteList'};
+    $$templateVars{'site'} = $config->{'site'};
+    #$$templateVars{'showWgList'} = $showWgList;
     $$templateVars{'showOrganization'} = $showOrganization;
     $$templateVars{'hasKeyword'} = $hasKeyword;
     $$templateVars{'hasTemporal'} = $hasTemporal;
@@ -2098,9 +2056,9 @@
     $$templateVars{'hasSpatial'} = $hasSpatial;
     $$templateVars{'hasTaxonomic'} = $hasTaxonomic;
     $$templateVars{'hasMethod'} = $hasMethod;
-    $$templateVars{'spatialRequired'} = $spatialRequired;
-    $$templateVars{'contactEmailAddressRequired'} = $contactEmailAddressRequired;
-    $$templateVars{'temporalRequired'} = $temporalRequired;
+    $$templateVars{'spatialRequired'} = $required->{'spatialRequired'};
+    $$templateVars{'contactEmailAddressRequired'} = $required->{'contactEmail'};
+    $$templateVars{'temporalRequired'} = $required->{'temporal'};
 
     # find out the tag <alternateIdentifier>. 
     $results = $doc->findnodes('//dataset/alternateIdentifier');
@@ -2200,8 +2158,6 @@
                     $aoCount++;
                 }
             }
-            $$templateVars{'origEmail'} = findValue($node, '../electronicMailAddress');
-            $$templateVars{'origNameOrg'} = findValue($node, '../organizationName');
         }
 
     $results = $doc->findnodes('//dataset/creator/organizationName');
@@ -2214,7 +2170,7 @@
         foreach $node ($results->get_nodelist) {
             my $tempValue = findValue($node,'../organizationName');
             $tempResult = $node->findnodes('../individualName');
-            if ($tempResult->size == 0 && $tempValue ne $organization) {
+            if ($tempResult->size == 0 && $tempValue ne $config->{'organization'}) {
                 $$templateVars{'site'} = $tempValue;
             }
         }
